-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp, SQLskills.com
-- All Rights Reserved.
-- 
-- For more scripts, sample code and additional training resources,
-- go to http://www.SQLskills.com
--	Immerse yourself in SQL Server
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

-- See "SET Options That Affect Results" in BOL

--set ansi_nulls on or off
SELECT t.* 
FROM titles AS t
WHERE t.price IS NULL    -- works

SELECT t.* 
FROM titles AS t
WHERE t.price = NULL    -- only works when ansi nulls is OFF

-- Column nullability.
-- IF ansi_null_dflt_on is ON  (NOTE: off cannot be on)
--    The columns will allow nulls (defined with NULL)
-- IF ansi_null_dflt_on is OFF  (NOTE: off can be on/off)
--    Then it's not enough info - we need to know the opposite option and the db option state?
-- IF ansi_null_dflt_off is ON (NOTE: on cannot be on)
--    The columns will NOT allow nulls (defined with NOT NULL)
-- IF ansi_null_dflt_off is OFF (on can be on/off)
--    Then AGAIN it's not enough info - we need to know the opposite option and the db option state?

-- IF both options are OFF
--    Then it depends on the db option
-- IF the database option "columns null by default" or "ansi null default" is ON
--    The columns will allow nulls (defined with NULL)
-- IF the database option "columns null by default" or "ansi null default" is OFF
--    The columns will NOT allow nulls (defined with NOT NULL)

-- What's the moral of the story? 
-- DO NOT LEAVE THE NULLABILITY OFF WHEN DEFINING A TABLE!
CREATE TABLE dbo.TableName
(
    Col1    int    NOT NULL
)

