-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp, SQLskills.com
-- All Rights Reserved.
-- 
-- For more scripts, sample code and additional training resources,
-- go to http://www.SQLskills.com
--	Immerse yourself in SQL Server
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

-- First, create the table without any rows (1=2 will never exist) 
SELECT getdate() AS CurrentTime, * 
INTO #tempsysperfinfo
FROM master.dbo.sysperfinfo
WHERE 1=2

-- Add a row to see how it looks, etc.
INSERT #tempsysperfinfo
SELECT getdate(), *
FROM master.dbo.sysperfinfo AS perf
	WHERE perf.[object_name] = 'SQLServer:Databases'
		AND perf.[counter_name] = 'Percent Log Used'
		AND perf.[instance_name] = 'credit'

-- Review the data.
SELECT * FROM #tempsysperfinfo

-- Or run something every 10 seconds:
-- And then create this as a recursive job where step one 
-- and step two are the same and execute the other on both 
-- success or failure.

WHILE 1=1
BEGIN
	INSERT #tempsysperfinfo
	SELECT getdate(), *
	FROM master.dbo.sysperfinfo
--	WHERE...
	WAITFOR DELAY '00:00:00.10'
END
