-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp, SQLskills.com
-- All Rights Reserved.
-- 
-- For more scripts, sample code and additional training resources,
-- go to http://www.SQLskills.com
--	Immerse yourself in SQL Server
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

-- To see all of your indexes and the last time the stats were updated
SELECT 
	object_name(si.[id]) 			AS [TableName]
	, rowcnt 						AS [RowCount]
	, CASE 
		WHEN si.indid = 0 then 'Heap'
		WHEN si.indid = 1 then 'CL'
		WHEN INDEXPROPERTY ( si.[id], si.[name], 'IsAutoStatistics') = 1 THEN 'Stats-Auto'
		WHEN INDEXPROPERTY ( si.[id], si.[name], 'IsHypothetical') = 1 THEN 'Stats-HIND'
		WHEN INDEXPROPERTY ( si.[id], si.[name], 'IsStatistics') = 1 THEN 'Stats-User'
		WHEN si.indid BETWEEN 2 AND 250 THEN 'NC ' + RIGHT('00' + convert(varchar, si.indid), 3)
		ELSE 'Text/Image'
	  END 							AS [IndexType]
	, si.[name] 						AS [IndexName]
	, si.indid						AS [IndexID]
	, CASE
		WHEN si.indid BETWEEN 1 AND 250 AND STATS_DATE (si.[id], si.indid) < DATEADD(m, -1, getdate()) 
			THEN '!! More than a month OLD !!'
		WHEN si.indid BETWEEN 1 AND 250 AND STATS_DATE (si.[id], si.indid) < DATEADD(wk, -1, getdate()) 
			THEN '! Within the past month !'
		WHEN si.indid BETWEEN 1 AND 250 THEN 'Stats recent'
		ELSE ''
	  END 							AS [Warning]
	, STATS_DATE (si.[id], si.indid) 	AS [Last Stats Update]
FROM sysindexes AS si
WHERE OBJECTPROPERTY(si.[id], 'IsUserTable') = 1
ORDER BY [TableName], si.[indid]

-- To see only the indexes whose stats are VERY old!

SELECT 
	object_name(si.[id]) 			AS [TableName]
	, rowcnt 						AS [RowCount]
	, CASE 
		WHEN si.indid = 0 then 'Heap'
		WHEN si.indid = 1 then 'CL'
		WHEN INDEXPROPERTY ( si.[id], si.[name], 'IsAutoStatistics') = 1 THEN 'Stats-Auto'
		WHEN INDEXPROPERTY ( si.[id], si.[name], 'IsHypothetical') = 1 THEN 'Stats-HIND'
		WHEN INDEXPROPERTY ( si.[id], si.[name], 'IsStatistics') = 1 THEN 'Stats-User'
		WHEN si.indid BETWEEN 2 AND 250 THEN 'NC ' + RIGHT('00' + convert(varchar, si.indid), 3)
		ELSE 'Text/Image'
	  END 							AS [IndexType]
	, si.[name] 						AS [IndexName]
	, si.indid						AS [IndexID]
	, CASE
		WHEN si.indid BETWEEN 1 AND 250 AND STATS_DATE (si.[id], si.indid) < DATEADD(m, -1, getdate()) 
			THEN '!! More than a month OLD !!'
		WHEN si.indid BETWEEN 1 AND 250 AND STATS_DATE (si.[id], si.indid) < DATEADD(wk, -1, getdate()) 
			THEN '! Within the past month !'
		WHEN si.indid BETWEEN 1 AND 250 THEN 'Stats recent'
		ELSE ''
	  END 							AS [Warning]
	, STATS_DATE (si.[id], si.indid) 	AS [Last Stats Update]
FROM sysindexes AS si
WHERE OBJECTPROPERTY(id, 'IsUserTable') = 1
	AND STATS_DATE (si.[id], si.indid) < DATEADD(m, -1, getdate()) 
ORDER BY [TableName], si.[indid]
